/*globals Kinetic: true*/


//define io for sencha builder to work
//if we're including Kinetic properly, then this call is harmless
if(window.Kinetic === undefined) {
    Kinetic = {};
}




/**
 * Utility for logger. safer than using console.log as IE errors on it. 
 */
Ext.define("BLogger", {
    singleton: true,
    log: function(msg) {
        "use strict";
        if(window.console && window.console.log) {
            window.console.log(msg);
        }
    }
});

Ext.Loader.setConfig({
    enabled : true, //enable the dynamic dependency loading feature
    disableCaching : false //Comment this line out when you need to reload your Extjs js files
});
 
 
 
Ext.application({
    name: 'FP',
    appFolder: 'app',
    requires: [ 
        'Ext.app.Controller', 
        'Ext.Ajax', 
        'FP.utils.IframeSlave'
    ],
    parseURLOptions: function() {
        "use strict";
        var query = window.location.search.slice(1),//skip '?'
            me = this;
        
        this.windowOptions = {};
        if(query) {
            Ext.Array.forEach(query.split('&'),function(item) {
                var splitEquals = item.split('='),
                    name = splitEquals[0],
                    value = splitEquals[1];

                me.windowOptions[name] = value; 
            });
        }
    },
    createMainView: function() {
        "use strict";
        var iframe;
        if(this.windowOptions.view !== 'off')  {
            Ext.create('FP.view.FrontPanel', {renderTo: Ext.getBody()});
        }
        if(this.windowOptions.oframe) {
            //dynamically add controller for iframe
            iframe = Ext.create('FP.utils.IframeSlave', {originURI: this.windowOptions.oframe});
            iframe.loadController(this.controllers.getByKey('FrontPanelControlExt'));
        }
    },
    launch: function() {
        "use strict";
        this.parseURLOptions();
        this.createMainView();
        
        window.myapp = this;
        
        
    },
    controllers: [
        'FrontPanelControlExt'
    ]
});

