
Ext.define('PrePro.view.mobile.Main', {
    extend: 'Ext.Panel',
    alias: 'widget.frontpanel',
    xtype: 'MblMain',
    requires: [
        'PrePro.view.mobile.FrontPanelMbl',
        'Ext.Toolbar',
        'Ext.Spacer'
    ],
    config: {    
        layout: {
            type: 'vbox',
            pack: 'center'
        },
        cls: 'maincontainer',
        fullscreen: true,
        items: [
            {
                xtype: 'spacer'
            },
            {
                xtype: 'container',
                layout: {
                    type: 'hbox',
                    pack: 'center'
                },
                items: Ext.create('PrePro.view.mobile.FrontPanelMbl')
            },
            {
                xtype: 'spacer'
            },
            {
                xtype: 'toolbar',
                ui: 'barco',
                defaults: {
                    ui: 'barco',
                    cls: 'autoexpand'
                },
                layout: {
                    type: 'hbox',
                    pack: 'center'
                },
                items: [
                    {
                        id: 'key_1',
                        text: '1'
                    },
                    {
                        id: 'key_2',
                        text: '2'
                    },
                    {
                        id: 'key_3',
                        text: '3'
                    },
                    {
                        id: 'key_4',
                        text: '4'
                    }
                ]
            },
            {
                xtype: 'toolbar',
                ui: 'barco',
                defaults: {
                    ui: 'barco',
                    cls: 'autoexpand'
                },
                layout: {
                    type: 'hbox',
                    pack: 'center'
                },
                items: [
                    {
                        id: 'key_5',
                        text: '5'
                    },
                    {
                        id: 'key_6',
                        text: '6'
                    },
                    {
                        id: 'key_logo',
                        text: 'LOGO'
                    },
                    {
                        text: 'BLK',
                        id: 'key_blk'
                    }
                ]
            },
            {
                xtype: 'toolbar',
                ui: 'barco',
                //for some reason using pack in layout does not work for vbox. 
                cls: 'middle autoshrink',
                docked: 'right',
                defaults: {
                    ui: 'barco'
                },
                layout: {
                    type: 'vbox',
                    pack: 'center',
                    align: 'middle'
                },
                items: [
                    {
                        id: 'key_up',
                        text: 'Up'
                    },
                    {
                        id: 'key_sel',
                        text: 'Sel'
                    },
                    {
                        id: 'key_esc',
                        text: 'Esc'
                    },
                    {
                        id: 'key_down',
                        text: 'Down'
                    },
                    {
                        xtype: 'spacer'
                    }, 
                    {
                        text: 'FRZ',
                        id: 'key_frz'
                    },
                    {
                        text: 'Setup',
                        id: 'key_setup'
                    },
                    {
                        text: 'Pan/Zoom',
                        id: 'key_panzoom'
                    },
                    {
                        text: 'Test Pattern',
                        id: 'key_tp'
                    }
                ]
            }
        ]
    },
    setVFDText: function(converted) {
        var spans = this.down('vfd').element.select('pre'),
            el;
        
        for(var idx = 0; idx < converted.length; idx+=1) {
            el = Ext.get(spans.elements[idx]);
            el.setText(converted[idx]);
        }
    },
    setLedState: function(ledStateObj) {
        var buttons = this.query('button');
        var ledState = null,
            currButton = null;
        for(var idx = 0; idx < buttons.length; idx +=1) {
            currButton = buttons[idx];
            ledState = ledStateObj[currButton.id];
            if(ledState !== undefined) {
                switch(ledState) {
                    case 0:
                        currButton.removeCls('litup');
                        currButton.removeCls('flash');
                        break;
                    case 1:
                        currButton.addCls('litup');
                        currButton.removeCls('flash');
                        break;
                    case 2:
                        currButton.removeCls('litup');
                        currButton.addCls('flash');
                }
            }
        }
    }
});


