/**
 * Main grid to show all units added so far
 */
Ext.define('Muc.view.UnitsGrid', {
    extend: 'Ext.grid.Panel',
    requires: ['Ext.grid.plugin.DragDrop'],
    frame: true,
    alias: 'widget.unitsgrid',
    title: 'Unit List',
    store: 'UnitS',
    ui: 'dark',
    multiSelect: true,
    viewConfig: {
        plugins: {
            ptype: 'gridviewdragdrop',
            dragText: 'Drag and drop to reorder'
        }
    },
    columns: [
        {
            text: 'Name',
            dataIndex: 'name'
        }, {
            text: 'Description',
            flex: 1,
            dataIndex: 'description'
        }, {
            text: 'IP',
            dataIndex: 'ip-address'
        }, {
            text: 'Input',
            dataIndex: 'input',
            renderer: function(value) {
                return Ext.String.format('<div class="x-grid-cell-barco" style="text-align: center;">{0}</div>', value);
            }
        }, {
            text: 'Freeze',
            dataIndex: 'freeze',
            renderer: function(value) {
                return Ext.String.format('<div class="x-grid-cell-barco" style="text-align: center;">{0}</div>', value);
            }
        }
    ],
    buttons: [
        {
            text: 'Save Settings',
            action: 'saveunit'
        },
        {
            text: 'Remove',
            action: 'remove'
        },
        {
            xtype: 'tbfill'
        },
        {
            text: 'Manual Add',
            action: 'add'
        }
    ]
});

