
/*global barco:true*/
/*global $:true*/
/*jslint white: true, onevar: true, undef: true, nomen: true, eqeqeq: true, plusplus: true, bitwise: true, regexp: true, newcap: true, immed: true */

function validateTarGz(fileName) {
    "use strict";
    var pattern = new RegExp("\\.tar\\.gz$", "i"),
        patternIE = new RegExp("\\.tar\\.tar$", "i");
    return (pattern.test(fileName) || patternIE.test(fileName));
}

 
/*
 * Function: createFileUploadDialog: 
 * arguments: opts: Dialog options object
 *      Contents:
 *          obj: <DOM element> generating the dialog
 *          operation: <string> name of operation
 *          url: <string> the url to post the file upload to
 */
 
function createFileUploadDialog(opts) {
    "use strict";
    opts = opts || {};
    var win,
        uploadPanelItems,
        uploadForm;
        
    uploadPanelItems = [
        {
            xtype: 'panel',
            layout: 'vbox',
            height: 75,
            width: 482,
            layoutConfig: {
                align : 'stretch',
                pack  : 'start'
            },
            items: [
        
        {
            xtype: 'textfield',
            fieldLabel: 'Upload file',
            height: 25,
            name: 'testfile',
            flex: 1,
            id: 'uploadfield',
           // padding: 10,
            inputType: 'file',
            allowBlank: false,
            listeners: {
                afterrender: function(cmp) {
                    if(opts.accepts) {
                        cmp.el.dom.setAttribute('accept', opts.accepts);
                    }
                    cmp.el.dom.setAttribute('size', 58);
                }
            }
        }, 
        {   
            xtype: 'panel',
            layout: 'hbox',
            layoutConfig: {
                pack: 'center'
            },
            items: [
                 {
                    xtype: 'radio',
                    fieldLabel: 'Anchovies',
                    boxLabel: 'Logo A',
                    name: 'LogoRadio',
                    id: 'radiologoA',
                    inputValue: 0,
                    checked:true,
                    hidden: !opts.logoRadio
                 },{
                    xtype: 'spacer',
                    width: 5,
                    hidden: !opts.logoRadio
                 },{
                    xtype: 'radio',
                    fieldLabel: 'Anchovies',
                    boxLabel: 'Logo B',
                    name: 'LogoRadio',
                    id: 'radiologoB',
                    inputValue: 1,
                    hidden: !opts.logoRadio
                 },{
                    xtype: 'spacer', 
                    width: 20,
                    hidden: !opts.logoRadio
                 },{
                    xtype: 'button',
                    text: 'submit',
                    //height: 30,
                    width: 80,
                    handler: function (btn) {

                            var innerDom = Ext.getCmp('dialogInnerPanel').body.dom;
                            if(!uploadForm.getForm().isValid()){
                                innerDom.innerHTML = "Select a File First.";
                                return;
                            }
                            if(opts.validator(Ext.getDom('uploadfield').value) == false){
                                if(opts.fileTypeMessage !== undefined ) {
                                    innerDom.innerHTML = opts.fileTypeMessage;
                                } else {
                                    innerDom.innerHTML = "File must have .tar.gz or .tar extension";
                                }
                                return;
                            }
                            innerDom.innerHTML = "Submitting file to server...";
                            if(opts.lockout) {
                                barco.lockFrontPanel();
                            }
                            uploadForm.getForm().submit(
                            {
                                url:opts.url,
                                success: function(fp, o) {
                                    innerDom.innerHTML += "<br>Done. <br> ";
                                    if(typeof opts.formSubmitHandler === 'function') {
                                        opts.formSubmitHandler.call(opts.scope);

                                    } else {
                                        uploadForm.doLayout();
                                        Ext.getCmp('restartPanel').show();
                                        uploadForm.doLayout();
                                    }

                                },
                                failure: function(fp, o) {
                                    if(opts.lockout) {
                                        barco.unlockFrontPanel();
                                    }
                                    innerDom.innerHTML += "<br>Failed: server result code: " + o.response.responseText;
                                }

                            }
                            );
                            btn.disable();

                        }
                }
//                {
//                    flex: 1
//                }
            ]
        }
        ]}
    ];
    
    if(opts.additionalFormItems !== undefined) {
        uploadPanelItems = uploadPanelItems.concat(opts.additionalFormItems);
    }
    
    uploadForm = new Ext.FormPanel({
            id: "uploadPanel",
            //method: 'POST',
            layout: {
                type:'vbox',
                align: 'stretch',
                pack: 'start'
            },
            fileUpload: true,
            items: [
                {
                    xtype: 'panel',
                    layout: 'hbox',
                    height: 51,
                    items: uploadPanelItems
                }, {
                    xtype: 'panel',
                    id: 'dialogInnerPanel',
                    //bodyStyle: 'padding:10px',
                    baseCls: 'bgColor', //see default.css
                    html: 'Choose a file for upload',
                    flex: 1
                }, {
                    xtype: 'panel',
                    id: 'restartPanel',
                    layout: 'hbox',
                    baseCls: 'yellowbg',
                    hidden: true,
                    items: [
                        {
                            xtype: 'label',
                            text: 'System must be restarted.'
                        },
                        {
                            xtype: 'spacer',
                            flex: 1
                        },
                        {
                            xtype: 'button',
                            text: 'Restart',
                            //TODO: remove, not used
                            handler: function(btn, evt) {
                                btn.disable();
                                var cnt; 
                                Ext.Ajax.request({
                                    method: 'POST',
                                    url: '/cgi-bin/RunCmd',
                                    jsonData: "reset\nexit\n",
                                    success: function(response, opts) {
                                        Ext.MessageBox.show({
                                            title: "Please wait",
                                            msg: "System Restart in Progress",
                                            progressText: 'working...',
                                            width: 300,
                                            progress: true,
                                            closable: false
                                        });
                                        
                                        var TF = function(v) {
                                                return function(){
                                                    if(v == 99){
                                                        Ext.MessageBox.hide();
                                                        window.location = window.location.href;
                                                    }else{
                                                        var i = v/99;
                                                        Ext.MessageBox.updateProgress(i, Math.round(100*i)+'% completed');
                                                    }
                                                   };
                                               };
                                       for(cnt = 1; cnt < 100; cnt++){
                                           setTimeout(TF(cnt), cnt*500);
                                       }
                                    
                                    },
                                    failure: function(response, opts) {
                                        Ext.MessageBox.alert("Error", 'server-side failure with status code ' + response.status);
                                    }
                                        
                                });
                            }
                        },
                        {
                            xtype: 'spacer',
                            width: 20
                        },
                        {
                            xtype: 'button',
                            text: 'Cancel',
                            handler: function(btn, evt) {
                                Ext.getCmp('restoreWindow').destroy();

                            }
                        }
                    ]
                }
            ]
        });
        win = new Ext.Window({
            id: 'restoreWindow',
            animateTarget: opts.obj,
            title: opts.title,
            //layout: 'vbox',
            layout:'fit',
            width:500,
            height:150,
            plain: true,
            modal: true,
            closable: true,
            items: [
                //putting restoreForm in another panel
                //fixes IE.
                new Ext.Panel({
                    deferredRender:false,
                    layout: 'fit',
                    border:false,
                    items: [
                        uploadForm
                    ]
                })
            ]
        });
        win.show();    
}

Ext.ns('barco');

barco.log = function(str){
    "use strict";
    //older versions of IE doesn't have console'
    if(window.console){
        console.log(str);
    }
};

barco.errorAlert = function(msg){
    "use strict";
    Ext.MessageBox.alert("Error", msg);
};

barco.handlesysbackup = function(obj) {
    "use strict";
    barco.log("handlesysback: " + obj.value);
    var showMessage = function () {
        barco.showProgressDialog(10, 'Backup in Progress', function() {
            //repeat until download command returns
            showMessage();
        }, true);
    };
    showMessage();
    barco.saveSysSettings(function() {
        Ext.Ajax.request({
            method: 'GET',
            timeout: 300*1000,
            url:'/cgi-bin/backupxml',
            success: function(response, opts) {
                barco.hideProgressDialog();
                try {
                    barco.log(response);
                    var jsresp = Ext.decode(response.responseText);
                    if(jsresp.filename != null) {
                        $('#sysbackuplink').remove();
                        $('#sysrestore').after('<a ' + 'href=' + jsresp.filename + ' id="sysbackuplink" style="padding-left: 10px; padding-top: 3px; float: left">Right Click, Save As... if your browser blocks the download</a>');
                        window.open('/' + jsresp.filename, 'Download');                        
                    }

                }
                catch(err) {
                    barco.errorAlert("server-side failure 1: " + response.responseText);
                }
            },
            failure: function(response, opts) {
                barco.hideProgressDialog();
                barco.errorAlert("server-side failure 2: " + response.responseText);
            }
        });
    });
};

barco.handlesysupgrade = function (el) {
    "use strict";
    var options = {
        url: "/cgi-bin/upgrade",
        operation: "Firmware Upgrade",
        obj: el,
        title: 'System Firmware Upgrade',
        validator: validateTarGz, 
        lockout: true,
        formSubmitHandler: function() {
            var showMessage, afterSave, reloadRetries = 0; 
            
            afterSave = function() {
                Ext.Ajax.request({
                   method: 'POST',
                   url: 'cgi-bin/RunCmd',
                   jsonData: 'USBUTIL -i /tmp/upgrade.tar.gz\nexit\n'

                });
            };
            showMessage = function() {
                barco.showProgressDialog(60, "Upgrade in Progress...", function() {                        
                    reloadRetries += 1;
                    showMessage();
                    Ext.Ajax.request({
                        method: 'POST',
                        jsonData: "rev\nexit\n",
                        url: '/cgi-bin/RunCmd',
                        timeout:5*1000,
                        success: function(resp) {
                            if(resp.responseText.length > 80) {
                                //if we get the rev then the board is up
                                barco.hideProgressDialog();
                                window.location = window.location.href;
                            }
                        }, 
                        failure: function(){
                            if(reloadRetries >= 6) {
                                barco.hideProgressDialog();
                                Ext.MessageBox.alert("Warning", 'Failed to communicate with unit after upgrade. Check connection', function() {
                                        window.location = window.location.href;
                                    }
                                );
                            }
                        }
                    });
                    
                }, true);
            };
            showMessage();
            barco.saveSysSettings(afterSave);
        },
        scope: barco
    };
    createFileUploadDialog(options);
};

barco.handlelogobackup = function(obj) {
    "use strict";
    barco.getSystemMode(barco.handlelogobackupDelayed, obj);
};

barco.handlelogobackupDelayed = function(obj) {
    "use strict";
    if (barco.systemMode==3) {  // 3 is MinDelayMode
        Ext.MessageBox.alert("Warning", 'Logo Export is not available when System is in MinDelay Mode.');
        return;
    }
        
    var showMessage = function () {
        barco.showProgressDialog(10, 'Logo Backup', function() {
            //repeat until download command returns
            if (barco.showDialog) {
                showMessage();
            }
        }, true);
    };
    showMessage();
    Ext.Ajax.request({
        method: 'POST',
        url: 'cgi-bin/RunCmd',
        timeout: 800*1000,
        jsonData: (barco.systemMode==1 ? 'logodown\n exit\n' : 'logodown --still 0\n exit\n'),
        success: function(response, opts) {                        
            $('#downlogo0').remove();
            $('#downlogo1').remove();
            // need to set status to 0, because getLogoPngStatus uses an AJAX call which is asynchronous to this.
            barco.logoPngStatus0 = 0;
            barco.logoPngStatus1 = 0;     
            barco.logoState0 = 5;   // "5", before status is queried, assume logo is ready.
            barco.logoState1 = 5;   // "5", before status is queried, assume logo is ready.
            var responseCode = barco.getResponseCode(response),
                delayF, aft, found0, found1,
                checkPngStatus, scheduleTimer, getImageAndDisplay, bDone;
            if(responseCode < 0) {                
                barco.hideProgressDialog();
                Ext.MessageBox.alert("Failed", "Logo Backup Failed with Code: " + responseCode);                                
            } else {
                bDone = false;                
                checkPngStatus = function() {                                      
                   barco.getLogoPngStatus(0);
                   barco.getLogoPngStatus(1);                    
                   bDone = (barco.systemMode==1 ? (barco.getDoneWithWaitForLogoPng(1) && barco.getDoneWithWaitForLogoPng(0)) : (barco.getDoneWithWaitForLogoPng(0)));
                   barco.log("bDone = " + String(bDone) + ", PNG1 = " + String(barco.logoPngStatus0) + ", PNG2 = " + String(barco.logoPngStatus1));
                   if (bDone) {
                       barco.hideProgressDialog();
                       getImageAndDisplay();
                   }
                   else {
                       scheduleTimer();
                   }
                };  
                
                scheduleTimer = function() {
                    setTimeout(checkPngStatus, 1000);
                };
                
                getImageAndDisplay = function () {
                   barco.log("GetImageAndDisplay");               
                 
                   found0 = (barco.logoPngStatus0 == 2);//responseCode==800 || responseCode==802;
                   found1 = (barco.logoPngStatus1 == 2);//responseCode==801 || responseCode==802;
                   aft = '';
                   if(found0){
                      aft += '<a href=downlogo0.png target="_blank"> <img id=downlogo0 src="downlogo0.png" alt="right-click save as"/></a>';
                   }
                   if(found1){
                      aft += '<a href=downlogo1.png target="_blank"> <img id=downlogo1 src="downlogo1.png" alt="right-click save as"/></a>';
                   }
                   $('#logorestore').after(aft);
                
                   delayF = function() {
                      var dummy;
                      if(found0){
                         dummy = new Ext.ToolTip({
                            target: 'downlogo0',
                            anchor: 'left',
                            anchorOffset: 15, // center the anchor on the tooltip
                            autoHide: true,
                            closable: true,
                            draggable: true,
                            html: 'Right-click, Save Image As...'
                         }).show();
                      }
                      if(found1){
                         dummy = new Ext.ToolTip({
                            target: 'downlogo1',
                            anchor: 'left',
                            anchorOffset: 15, // center the anchor on the tooltip
                            autoHide: true,
                            closable: true,
                            draggable: true,
                            html: 'Right-click, Save Image As...'
                         });
                      }
                   };
                
                   setTimeout(delayF, 1000); 
                };
                
                setTimeout(checkPngStatus, 5000);                
            }                                        
        }               
    });    
};

barco.handlelogorestore = function(obj) {
    "use strict";
    barco.getSystemMode(barco.handlelogorestoreDelayed, obj);
};

barco.handlelogorestoreDelayed = function(obj) {
    "use strict";
    if (barco.systemMode==3) {      // 3 is MinDelay Mode
        Ext.MessageBox.alert("Warning", 'Logo Import is not available when System is in MinDelay Mode.');
        return;
    }    
    var options = {
        url: "/cgi-bin/fileupload",
        operation: "Logo Restore",
        obj: obj,
        title: 'Logo Restore',
        logoRadio: barco.systemMode==1,
        validator: function(fileName) {
            var pattern = new RegExp("\\.png$", "i");
            return pattern.test(fileName);
        },
        accepts: 'image/png',
        fileTypeMessage: "Only PNG files supported",
        additionalFormItems: [
            {
                xtype: 'hidden',
                name: 'dest_name',
                value: 'uplogo.png'
            }
        ],
        formSubmitHandler: function() {
            var showMessage, logoNum = (barco.systemMode==1 && Ext.getCmp("radiologoB").getValue() ? 1 : 0);
            Ext.getCmp('restoreWindow').close();
            showMessage = function () {
                barco.showProgressDialog(10, 'Restoring Logo', function() {
                    //repeat until download command returns
                    showMessage();
                }, true);
            };
            showMessage();
            Ext.Ajax.request({
               method: 'POST',
               url: 'cgi-bin/RunCmd',
               timeout: 600*1000,
               jsonData: 'logoup --still ' + String(logoNum) +'\n exit\n',
               success: function(response, opts) {
                   barco.hideProgressDialog();
                   var responseCode = barco.getResponseCode(response);
                   if(responseCode === 0) {
                       $('#downlogo').remove();
                       Ext.MessageBox.alert("Logo Restore", "Logo restore completed.");
                   } else {
                       Ext.MessageBox.alert("Logo Restore", "Failed with code: " + responseCode);
                   }
               }
               
            });
        }
    };
    
    createFileUploadDialog(options);
};
    
barco.handlesysrestore = function(obj) {
    "use strict";
    var options = {
        url: "/cgi-bin/restorexml",
        operation: "System Restore",
        validator: validateTarGz, 
        obj: obj,
        title: 'XML Settings Restore',
        lockout: true,
        formSubmitHandler: function() {
            var showMessage, reloadRetries = 0; 
            showMessage = function() {
                barco.showProgressDialog(60, "Restore in Progress...", function() {
                    
                    reloadRetries += 1;
                    
                    showMessage();
                    Ext.Ajax.request({
                        method: 'POST',
                        jsonData: "rev\nexit\n",
                        url: '/cgi-bin/RunCmd',
                        timeout:5*1000,
                        success: function(resp) {
                            if(resp.responseText.length > 80) {
                                //if we get the rev then the board is up
                                barco.hideProgressDialog();
                                window.location = window.location.href;
                            }
                        },
                        failure: function() {
                            if(reloadRetries >= 6) {
                                barco.hideProgressDialog();
                                Ext.MessageBox.alert("Warning", 'Failed to communicate with unit after restore. Check connection', function() {
                                        window.location = window.location.href;
                                    }
                                );
                            }
                        }
                    });
                    
                }, true);
            };
            Ext.Ajax.request({
               method: 'POST',
               url: 'cgi-bin/RunCmd',
               jsonData: "sys -r 0\nexit\n",
               success: showMessage,
               failure: function(response) {
                   Ext.MessageBox.alert("Error", 'server-side failure with status code ' + response.status);
               }
            });
            
            
        },
        scope: barco
    };
    createFileUploadDialog(options);
};
    
barco.handleautoupgrade = function(button, link) {
    "use strict";
    var me = this,
        showMessage;
        
    barco.lockFrontPanel();
    Ext.Ajax.request({
        method: 'POST',
        jsonData: "wget " + link + " -O /tmp/upgrade.tar.gz > /dev/null 2> /dev/null; echo $? \nexit\n",
        timeout: 300*1000,
        url: '/cgi-bin/RunCmd?sys=1',
        success: function(res, obj) {
            barco.log("download finished");
            if(res.responseText[0] != "0") {
                //if the result from echo $? isn't 0, wget failed
                Ext.MessageBox.alert("Error", "Download Failed. Make sure device is connected to the internet.", function() {
                    barco.hideProgressDialog();
                });
                barco.unlockFrontPanel();
            } else {
                barco.hideProgressDialog();
                setTimeout(function() {
                    barco.showProgressDialog(300);
                }, 1500);
                Ext.Ajax.request({
                   method: 'POST',
                   url: 'cgi-bin/RunCmd',
                   jsonData: 'USBUTIL -i /tmp/upgrade.tar.gz\nexit\n'
                });
            }
        }
    });
    
    showMessage = function () {
        me.showProgressDialog(300, "Downloading package", function() {
            //repeat until download command returns
            showMessage();
        });
    };
    showMessage();
};

barco.hideProgressDialog = function() {
    "use strict";
    //barco.log("HideProgressDialog");
    this.showDialog = false;
    Ext.MessageBox.hide();
};

barco.showProgressDialog = function (waitTime, msg, completedCb, noProgressText) {
    "use strict";
    var tick = 0, 
        incrementProgress, 
        scheduleTimer;
    //barco.log("ShowProgressDialog");
    this.showDialog = true;
    if(waitTime===undefined) {
        waitTime=250;
    }
    if(msg===undefined) {
        msg="System Restart in Progress";
    }
    Ext.MessageBox.show({
        title: "Please wait",
        msg: msg,
        progressText: 'working...',
        width: 300,
        progress: true,
        closable: false
    });
    
    scheduleTimer = function(timeout) {
        setTimeout(incrementProgress, timeout);
    };
    incrementProgress = function() {
        if(barco.showDialog === false) {
            //barco.log("dying");
            return;
        }
        var i = tick/waitTime;
        barco.log(i);
        if(noProgressText !== true) {
            Ext.MessageBox.updateProgress(i, Math.round(100*i)+'% completed');
        } else {
            Ext.MessageBox.updateProgress(i, 'working...');
        }
        if(tick >= waitTime){
            barco.log("Done");
            if(typeof completedCb === 'function') {
                completedCb();
            } else {
                barco.hideProgressDialog();
                window.location = window.location.href;
            }
        } else {
            tick+=1;
            scheduleTimer(500);
        }

    };
    scheduleTimer(500);
};
    
barco.readyFunc = function() {
    "use strict";
    
    //load settings
    if(barco !== undefined && barco.settings !== undefined){
        document.getElementById("deviceNameTag").textContent = barco.settings.devicename;
    }
    else{
        document.getElementById("deviceNameTag").textContent = "settings missing";
    }
    var webapp = "/#",
        handleItems = [
            '#sysrestore',  
            '#sysbackup', 
            '#sysupgrade',
            '#logobackup',
            '#logorestore'
        ],
        getFPGA_temperature;
        
    //fade in the main container;
    $('#container').fadeIn({duration: 2000});
    
    if(Ext.isWebKit == false ) {
        $($('#gotowebapp').siblings()[0]).after('<p class="highlight"> It appears you are not running a webkit compatible browser. <br/> Please download Google Chrome, Apple Safari or Google Chrome Frame for Internet Explorer.</p>');
        $('#gotowebapp').css('opacity', 0.4);
    } else {
        webapp = "http://" + window.location.hostname + ":4800/mobile/index.html";
        barco.log("webkit");
    }
    $('#gotowebapp').attr({
            href: webapp
    });
    
     
    $(handleItems.join(', ')).mousedown(function(event) {
        var handle = barco['handle' + $(this)[0].id];
        if(handle !== undefined){
            handle.call(barco, this);
        } else {
            barco.log("no handle found for " + $(this)[0].id);
        }
    });
    
    getFPGA_temperature = function() {
        Ext.Ajax.request({
            method: 'POST',
            url: '/cgi-bin/RunCmd',
            jsonData: "fanctrl\nexit\n",
            success: function(response, opts) {
                var idxofdot,
                    trim;
                
                //FPGA temperature is the first floating point value
                idxofdot = response.responseText.indexOf('.');
                trim = response.responseText.slice(idxofdot - 4, idxofdot + 3);
                $('#fpgatempreadout').html(trim);
            }});
        setTimeout(getFPGA_temperature, 10000);
    }; 
    getFPGA_temperature();
    barco.getSystemMode();
    barco.getSystemType();    
};

barco.applyHighLight = function() {
    "use strict";
    $('#newdiv').addClass('highlight');
};

barco.clearHighLight = function() {
    "use strict";
    $('#newdiv').removeClass('highlight');
};

barco.appendRev = function() {
    "use strict";
    Ext.Ajax.request({
        method: 'POST',
        jsonData: "rev\nexit\n",
        url: '/cgi-bin/RunCmd',
        success: function(res, obj) {
            var splitList = res.responseText.split('\n'),
                strItems = [],
                idx,
                colonIdx,
                revList,
                buildInfoKey,
                revStartIdx,
                revEndIdx,
                buildInfoValue,
                style,
                template = new Ext.XTemplate(
                    '<li' + 
                        '<tpl if="style">' + 
                            ' style="{style}"' +
                        '</tpl>' + 
                        '>' +
                        '<span>{key}</span>{value}' +
                    '</li>');
                
                template.compile();

            for(idx = 0; idx < splitList.length; idx+=1) {
                colonIdx = splitList[idx].indexOf(':');
                if(colonIdx != -1) {
                    buildInfoKey = splitList[idx].slice(0, colonIdx);
                    buildInfoValue = splitList[idx].slice(colonIdx);
                    style = false;
                    if(buildInfoKey === 'BARCO') {
                        buildInfoKey = 'Build Info';
                        style = "font-weight: bold;";
                        /* Find the index of the first '.' in 00.00.XX
                         * subtract 2 get the index of version start
                         * keep going until comma*/
                        revStartIdx = buildInfoValue.indexOf('.');
                        if(revStartIdx != -1) {
                            revEndIdx = buildInfoValue.slice(revStartIdx).indexOf(',') + revStartIdx;
                            barco.currentRev = buildInfoValue.slice(revStartIdx-2, revEndIdx);
                        }
                        
                    }
                    strItems.push(template.apply(
                        {
                            key: buildInfoKey, 
                            value: buildInfoValue, 
                            style: style
                        }
                    ));        
                } 
            }

            revList = $('#revlist');
            $.each(strItems, function(idx, value) {
                revList.append($(value));
            });
            
            if(barco.settings && barco.settings.bprocessor) {
                barco.log('upgrade not available');
                
            } else {
                barco.checkForUpgrade();
            }
        },
        failure: function(res, obj) {
            
        }
    });
};

barco.checkForUpgrade = function() {
    "use strict";
    Ext.ux.JSONP.request('http://update.barco.com/ImagePro2/imagepro2_upgrade.json', 
        {
            callback: function(data) {
                var upgradeContainer,
                    upgradeTextTempl,
                    upgradeButton,
                    newVersion = data.imagepro2_upgrade.available_version;
                if( newVersion > barco.currentRev) {
                    barco.log("Upgrade is available");
                    upgradeTextTempl = new Ext.XTemplate(
                        '<p class=highlight> New Firmware, Version {version} is available for Auto Upgrade! </p>'
                    );
                    upgradeButton = '<div id="autoupgrade" class="fancy">' +
                                        "<span>Auto Upgrade</span" +
                                    "</div>";
                    upgradeContainer = $('#autoupgradecontainer');
                    upgradeContainer.append(upgradeTextTempl.apply({version: newVersion}));
                    upgradeContainer.append(upgradeButton);
                    barco.animateDiv($('#autoupgrade'));
                    $('#autoupgrade').mousedown(function(event) {
                        Ext.MessageBox.confirm('Confirm', 'Unit needs internet access, and upgrade may take several minutes. Continue?',
                            function(btn) {
                                if(btn === "yes") {
                                    barco.handleautoupgrade(this, data.imagepro2_upgrade.link);
                                }
                            }
                        );
                    });
                    
                } else {
                    barco.log("You Have the latest firmware");
                }
            }
        }
    );
};

barco.upgrade = {
    callback: function() {
        "use strict";
        Ext.ux.JSONP.callback.apply(Ext.ux.JSONP, arguments);
    }
};


barco.handleTabs = function () {
    "use strict";
    $('#tabcontainer > div').hide();
    $('#tabcontainer > div:first').show();
    $('#tabs ul li:first').addClass('active');
    
    $('#tabs ul li a').click(function(){
        $('#tabs ul li').removeClass('active');
        $(this).parent().addClass('active');
        var currentTab = $(this).attr('href');
        $('#tabcontainer > div').hide();
        $(currentTab).fadeIn();
        return false;
    });
    this.animateDiv('.innertab-content .fancy');
    
    barco.appendRev();
};

barco.lockFrontPanel = function() {
    "use strict";
    Ext.Ajax.request({
        method: 'POST',
        jsonData: 'LOCKOUT 1\nexit\n',
        url: '/cgi-bin/RunCmd'
    });
    //also put colugo in nice mode to reduce CPU utilization
    Ext.Ajax.request({
        method: 'POST',
        jsonData: 'sysfunc --mode 1\nexit\n',
        url: '/cgi-bin/RunCmd'
    });
};

barco.unlockFrontPanel = function() {
    "use strict";
    Ext.Ajax.request({
        method: 'POST',
        jsonData: 'LOCKOUT 0\nexit\n',
        url: '/cgi-bin/RunCmd'
    });    
    
    Ext.Ajax.request({
        method: 'POST',
        jsonData: 'sysfunc --mode 0\nexit\n',
        url: '/cgi-bin/RunCmd'
    });
};

barco.saveSysSettings = function(handler) {
    "use strict";
    Ext.Ajax.request({
        method: 'POST',
        url: 'cgi-bin/RunCmd',
        jsonData: 'save\nexit\n',
        success: handler,
        failure: function() {
           barco.hideProgressDialog(); //in case there is one
           Ext.MessageBox.alert("Error", 'Failed to save system settings');
        }
    });
};

barco.animateDiv = function(selector) {
    "use strict";
    var resetAttr = {'padding-left': '4px'};
    $(selector).hover(function(obj) {
        $(this).addClass("is-hovering");
        $(this).removeClass('is-animation-done');
        $(this).animate(
                {   
                    'padding-left': '20px'
                }, 
                {
                    duration: 200, 
                    queue: false, 
                    complete: function() {
                        if($(this).hasClass('is-hovering') === false) {
                            $(this).addClass('is-animation-done');
                            $(this).css(resetAttr);
                        }
                    }
                });
    }, function(obj){
        if($(this).hasClass('is-animation-done') === false) {
            $(this).animate(resetAttr, 200);
        }
        $(this).removeClass("is-hovering");
    });
};

barco.getResponseCode = function(response) {
    "use strict";
    var responseCode = null;
    //console.debug(response.responseText);
    try {
        responseCode = parseInt(response.responseText.split('-e ')[1].split('\n')[0], 10);
    } catch(exception) {
      
    }
    return responseCode;
};

barco.getSystemMode = function(callbackfunct, callbackvars) {
    "use strict";
    Ext.Ajax.request({
        method: 'POST',
        url: 'cgi-bin/RunCmd',
        timeout: 400*1000,
        jsonData: 'SYSMGR?\n exit\n',
        success: function(response){
            try {
                barco.systemMode = parseInt(response.responseText.split('--opmode ')[1].split(' ')[0], 10);
            } catch(exception) {
                barco.systemMode = 0;
            }                    
        },
        callback: function(options, success, response) {
            if(typeof callbackfunct === 'function'){
                callbackfunct(callbackvars);
            }
        }
    });
};

barco.getSystemType = function(callbackfunct, callbackvars) {
    "use strict";
    Ext.Ajax.request({
        method: 'POST',
        url: 'cgi-bin/RunCmd',
        timeout: 400*1000,
        jsonData: 'SYSMGR --qall\n exit\n',
        success: function(response){
            try {
                var res = RegExp("<SysType>(\\d)</SysType>").exec(response.responseText);
                if(res.length){
                   barco.SystemType = parseInt(res[1], 10);
                }else{
                   barco.SystemType = 0;
                }
            } catch(exception) {
                barco.SystemType = 0;
            }
        },
        callback: function(options, success, response) {
           if(typeof callbackfunct === 'function'){
              callbackfunct(callbackvars);
           }
        }
    });
};

barco.getLogoPngStatus = function(selector) {
    "use strict";    
    Ext.Ajax.request({
        method: 'POST',
        url: 'cgi-bin/RunCmd',
        timeout: 400*1000,
        jsonData: 'STILL? --still ' + String(selector) + '\n exit\n',
        success: function(response){
            try {
                if (selector) {
                    barco.logoPngStatus1 = parseInt(response.responseText.split('--pngstate ')[1].split(' ')[0], 10);
                    barco.logoState1 = parseInt(response.responseText.split('--state ')[1].split(' ')[0], 10);
                }
                else {
                    barco.logoPngStatus0 = parseInt(response.responseText.split('--pngstate ')[1].split(' ')[0], 10);
                    barco.logoState0 = parseInt(response.responseText.split('--state ')[1].split(' ')[0], 10);
                }
            } catch(exception) {
                if (selector) {
                    barco.logoPngStatus1 = 0;
                    barco.logoState1 = 0;
                }
                else {
                    barco.logoPngStatus0 = 0;
                    barco.logoState0 = 0;
                }
            }                    
        } 
    });    
};

// Done with wait if the png file is ready or the raw logo is not ready.
barco.getDoneWithWaitForLogoPng = function(selector) {
    "use strict"; 
    if (selector) {        
        if ((barco.logoPngStatus1 == 2) || 
            ((barco.logoState1 != 5) && (barco.logoState1 != 8))) {       
            return true;
        }
        else {
            return false;
        }
    }
    else {        
        if ((barco.logoPngStatus0 == 2) || 
            ((barco.logoState0 != 5) && (barco.logoState0 != 8))) {       
            return true;
        }
        else {
            return false;
        }
    }
};

$(document).ready(function() {
    "use strict";
    barco.readyFunc();
    barco.handleTabs();
});
