
barco.EdidConfigPanel = Ext.extend(Ext.Panel, {
    cls: 'barcolist',
    id: 'edidconfig',
    scroll: 'verticle',
    maxItemsAllowed: 20,
    defaults:{
        xtype:"barcolistitem",
        description: "",
        listeners: {
            'change': function() {
                "use strict";
                var idx,
                    itemList = this.ownerCt.items.items;
                Ext.getCmp('edid-auto-config-button').enable();
                itemList.forEach(function (item, idx) {
                    if(item.xtype == "barcolistitem") {
                        item.removeCls(item.pressedCls);
                    }
                });
                this.addCls(this.pressedCls);
                this.ownerCt.selectedItem = this.ownerCt.items.indexOf(this);
                //console.debug("selectedItem: "+this.ownerCt.selectedItem);
            }
        }
    },
    listeners: {
        beforerender: function(bar){
            "use strict";
            if(barco.utils.isImageProJr()){
                Ext.getCmp('edidconfighdmi').setVisible(false).setDisabled(true);
                Ext.getCmp('edidconfigdp').setVisible(false).setDisabled(true);
            }
        }
    },    
    items:[
       {
           initialValue: "DVI"
       },
       {
           initialValue: "HD-15"
       },
       {
           id: 'edidconfighdmi',
           initialValue: "HDMI"
       },
       {
           id: 'edidconfigdp',
           initialValue: "DP"
       },
       {
           xtype: 'panel',
           //baseCls: 'noclass',

           layout: {
               type:'hbox'
           },
           items: [{
               xtype: 'spacer'
           },{
               xtype: 'button',
               text: 'Auto Config',
               ui  : 'confirm-round',
               disabled: true,
               //width: '142px',
               //height: '52px',
               cls: 'edidbutton',
               id: 'edid-auto-config-button',
               templ: new Ext.XTemplate('<ImagePRO2 Num="0"><CmdType>1</CmdType>',
               '<OutputMgr Num="0"><OutAutoConfig>{outp}</OutAutoConfig></OutputMgr></ImagePRO2>'),
               handler: function(btn) {
                   "use strict";
                   var me = this;
                   if(this.ownerCt.ownerCt.selectedItem==null)
                   {
                       return;
                   }
                   barco.utils.ajaxRequest({
                       request:this.templ.apply({outp:this.ownerCt.ownerCt.selectedItem}),
                       success:function(response, opts, respCode) {
                           if(respCode>=0)
                           {
                               me.enable();
                               barco.utils.refreshNode(barco.utils.xmlselectnode(barco.tags.OutputMgr));
                           }
                           else
                           {
                               me.enable();
                               Ext.getCmp("edidconfigErrorMsg").popInAndOut();
                           }
                       }
                   });
                   this.disable();
               }
           },{
               xtype: 'spacer'
           }]
       },
       {
           id: 'edidconfigErrorMsg',
           xtype:'barcomodelessmessage',
           text:'Auto config failed. Output connector may not be connected.',
           hidden: true
       },
       {
           id: 'edidconfigFeatureNotAvailableMsg',
           xtype:'barcomodelessmessage',
           text:'Auto config is not available in this System Mode.',
           hidden: true
       }
    ],
    initComponent: function () {
        "use strict";
        this.selectedItem = null;
        barco.EdidConfigPanel.superclass.initComponent.call(this, arguments);
        this.on('show', function() {
                this.DisableControlForMinDelay();
        });
        barco.modelProxy.addCallback({
            func: this.DisableControlForMinDelay, 
            scope: this
        });
    },
    DisableControlForMinDelay: function() {
        "use strict";
        if(!this.rendered){
            return;
        }
        var isMinDelay, isQuadToDual, isImageProJr, item, i, length; 
        length = Ext.getCmp('edidconfig').items.length;
        isMinDelay = barco.utils.isMinDelayMode();
        isQuadToDual = barco.utils.isQuadToDualMode();
        isImageProJr = barco.utils.isImageProJr();
        for (i=0; i < length; i+=1)
        {
            item = Ext.getCmp('edidconfig').items.items[i];
            if (isMinDelay || isQuadToDual)
            {
                if (item.id == 'edidconfigFeatureNotAvailableMsg')
                {
                    item.show();                                    
                }
                else
                {
                    item.hide();                                    
                }
            }
            else              
            {
                if (item.id == 'edidconfigFeatureNotAvailableMsg')                
                {
                    item.hide();                                    
                }
                else
                {
                    if (item.id != 'edidconfigErrorMsg')
                    {
                        if( !isImageProJr || ( item.id != 'edidconfighdmi' && item.id != 'edidconfigdp') ){
                            item.show();
                        }else{
                            item.hide();
                        }
                    }
                }
            }
        }   
    }
});

