Ext.ns('barco.plugins');
Ext.ns('barco.form');
Ext.ns('barco.tags');

barco.Main = Ext.extend(Object, {
    init: function () {
        "use strict";
        barco.modelProxy.create();
        barco.evtManager = new barco.events.EventManager();
        Ext.Viewport.init();
        var panelWithButton = barco.utils.addRefreshButton();
        this.inputmain = panelWithButton(barco.InputMain);
        this.inputcolbal = panelWithButton(barco.InputColorBalance);
        this.inputaspectratio = panelWithButton(barco.InputAspectRatio);
        this.inputsizing = panelWithButton(barco.InputSizingAdjust);
        this.inputconfig = new barco.InputConfig();
        
        this.outputmain = panelWithButton(barco.OutputMain);
        this.outputcolorbal = panelWithButton(barco.OutputColorBalance);
        this.outputeffects = panelWithButton(barco.OutputColorEffects);
        this.outputaoirect = panelWithButton(barco.OutputAOIRect);        
        this.testpatterns = panelWithButton(barco.TestPatterns);
        this.panzoom = panelWithButton(barco.PanZoom);
        
        //this.ledsetupaoirect = panelWithButton(barco.OutputAOIRect, {id:'ledsetupaoirect'});
        //this.ledsetuppanzoom = panelWithButton(barco.PanZoom, {id:'ledsetuppanzoom'});
        
        barco.utils.addInnerPanelToolbar([
            {panel: this.outputcolorbal, allowBothChannels: true},
            {panel: this.outputeffects, allowBothChannels: true},
            {panel: this.outputaoirect},            
            {panel: this.panzoom},
           
           // {panel: this.ledsetuppanzoom},
           // {panel: this.ledsetupaoirect},
           
            {panel: this.inputaspectratio},
            {panel: this.inputsizing},
            {panel: this.testpatterns}
        ]);
        

        barco.utils.createWheelDispatcher();
        
        barco.edidconfigpanel = new barco.EdidConfigPanel();
        barco.commitHistory = new barco.CommitHistory();
        
        this.ui = new barco.mainui({
            title: 'Home',
            useTitleAsBackText: false,
            nagivationItems: barco.treemenu
        });
        
        barco.cometInst = new barco.Comet();
    }
});

Ext.setup({
    onReady: function() {
        "use strict";
        document.getElementsByTagName("title")[0].textContent = barco.utils.getHostname();
        var mainapp = new barco.Main();
        mainapp.init();
    }
});
