

barco.HomePanel = Ext.extend(Ext.form.FormPanel, {
    items: [{
            xtype: 'fieldset',
            title: 'Status',
            defaults: {
                labelWidth: '35%'
            },
            items: [
                Ext.applyIf({id: 'input-select-mainui'}, barco.InputFormatSelector),
                Ext.applyIf({id: 'output-select-mainui-1', label: 'Output Format Channel 1', index:0}, barco.OutputFormatSelector),
                Ext.applyIf({id: 'output-select-mainui-2', label: 'Output Format Channel 2', index:1}, barco.OutputFormatSelector),
                {
                    id:'panellock',
                    xtype: 'togglefield',
                    name: barco.tags.Lock,
                    label: 'Front Panel Lock',
                    listeners: {
                        change: function(obj, evt) {
                            "use strict";
                            if(barco.utils.store.rawxml){
                                var old = barco.utils.xmlselectnode(barco.tags.Lock).textContent;
                                if(old != obj.getValue() )
                                {
                                    barco.utils.store.setLocal(barco.tags.Lock, obj.getValue());
                                    barco.utils.ascii('LOCKOUT '+obj.getValue());
                                }
                            }
                            
                        }
                    }
                },
                {
                    id: 'system-mode-select',
                    xtype: 'selectfield',
                    name: barco.tags.OpMode,
                    label: 'System Mode',
                    options: [
                        {text: 'Standard', value: '0'}, 
                        {text: 'Dual Output', value: '1'},
                        {text: '3D', value: '2'},
                        {text: 'MinDly', value: '3'},
                        {text: 'Quad To Dual', value: '4'}
                    ],
                    listeners: {
                        change: function(obj, evt) {
                            "use strict";
                            var opMode = this.getValue(), //get value at the time change occured, (ignore async updates).
                                me = this,
                                reqFun = function(doit){
                                    if(!doit){
                                        console.debug("cancelling request");
                                        barco.modelProxy.genericCallBack.call(me.ownerCt.ownerCt, null, barco.modelProxy.stores.SystemStore); //revert
                                        return;
                                    }
                                    console.debug("requesting...");
                                    barco.utils.ajaxRequest({
                                        request: barco.modelProxy.stores.SystemStore.apply({
                                            tag: me.name,
                                            value: opMode
                                        }),
                                        scope: me,
                                        success: me.ajaxChangeSuccess,
                                        failure: function(){
                                            console.debug("failure");
                                        }
                                    });
                                };
                            // Show warning if going from Dual mode or 3D mode to Std mode or MinDelay mode.    
                            if((barco.utils.isDualMode() || barco.utils.is3DMode()) &&
                                ((opMode == 0) || (opMode == 3))) {                                
                                barco.HomePanel.warnpopup.acceptedCallback = reqFun;
                                barco.HomePanel.warnpopup.show();
                                return false;
                            }
                            else{
                                reqFun(true);
                            }
                        }
                    },
                    ajaxChangeSuccess: function(resp)
                    {
                        "use strict";
                        var err = barco.utils.getRespErrorCode(resp);
                        console.debug("success:"+String(err));
                        if(err<0 && barco.HomePanel.errpopups[err] !== undefined){
                            barco.HomePanel.errpopups[err].show();
                        }
                        barco.utils.refreshAll();
                    }
                }
            ]
    }],
    DisableControlForMinDelay: function() {
        "use strict";        
        var isMinDelay, i, length; 
        length = Ext.getCmp('theinputbar').items.length;
        isMinDelay = barco.utils.isMinDelayMode();
        for (i=0; i < length; i+=1)
        {
            if ((Ext.getCmp('theinputbar').items.items[i].text == "LOGO") || 
                (Ext.getCmp('theinputbar').items.items[i].text == "BLK") ||
                (Ext.getCmp('theinputbar').items.items[i].text == "FRZ"))
            {                
                Ext.getCmp('theinputbar').items.items[i].setDisabled(isMinDelay);
            }
        }               
    },
    DisableControlForQuadToDual: function() {
        "use strict";        
        var isQuadToDual, isMinDelay, length, i; 
        isQuadToDual = barco.utils.isQuadToDualMode();
        isMinDelay = barco.utils.isMinDelayMode();
        length = Ext.getCmp('theinputbar').items.length;
        for (i=0; i < length; i+=1)
        {
            if ((Ext.getCmp('theinputbar').items.items[i].text == "LOGO"))
            {                
                Ext.getCmp('theinputbar').items.items[i].setDisabled(isQuadToDual || isMinDelay);
            }
        }
        this.inputSelectMainui.setDisabled(isQuadToDual);
        this.outputSelectMainui1.setDisabled(isQuadToDual);
        this.outputSelectMainui2.setDisabled(isQuadToDual);          
    },
    constructor: function(config) {
        "use strict";
        barco.HomePanel.superclass.constructor.call(this, config);
        
        this.inputSelectMainui = Ext.getCmp('input-select-mainui');
        this.outputSelectMainui1 = Ext.getCmp('output-select-mainui-1');
        this.outputSelectMainui2 = Ext.getCmp('output-select-mainui-2');
        this.systemModeSelect = Ext.getCmp('system-mode-select');
              
        ///BProcessor: disable output
        if( barco.settings.bprocessor ){
            this.outputSelectMainui1.setVisible(false);
            this.outputSelectMainui2.setVisible(false);
            this.outputSelectMainui1 = {setVisible:function(){}};
            this.outputSelectMainui2 = {setVisible:function(){}};
            this.systemModeSelect.setVisible(false);
        }
        //////////////////////////////////
        
        var cbk = function(xml){
            barco.modelProxy.genericCallBack.call(this, null, barco.modelProxy.stores.SystemStore);
            if(!this.rendered){
                return;
            }
            this.inputSelectMainui.setVisible(!barco.utils.isInputStatic());
            
            if(!barco.utils.isSDI_2Ready() || barco.utils.isImageProJr() ){
                this.systemModeSelect.setOptions([{text: 'Standard', value: '0'}, {text: 'MinDly', value: '3'}]);
            }
            
            if (barco.utils.isDualMode()) {
                // 3D mode behave like dual channel expect for output format selection on ch 2.
                
                if (barco.utils.isDualMode()) {                    
                    this.outputSelectMainui2.setVisible(true);
                }
                else {
                    this.outputSelectMainui2.setVisible(false);
                }
                
                //show all A/B/Both segmented buttons
                if(!barco.evtManager.ShowChannelModeButton){
                    barco.evtManager.fireEvent('ShowChannelModeButton', true);
                }
            }
            else {
                // STD mode and MinDelay mode is behave like single channel.
                
                if(barco.evtManager.ChannelBoth){
                   barco.evtManager.fireEvent('ChannelBoth', false);
                }
                if(barco.evtManager.ChannelChange != 0){
                   barco.evtManager.fireEvent('ChannelChange', 0);
                }
                this.outputSelectMainui2.setVisible(false);
                
                //hide all A/B/Both segmented buttons
                if(barco.evtManager.ShowChannelModeButton){
                    barco.evtManager.fireEvent('ShowChannelModeButton', false);
                }
            }
            // Need to disable Logo, Black and Freeze when in MinDelay mode
            
            this.DisableControlForMinDelay();
            this.DisableControlForQuadToDual();
        };
        barco.modelProxy.addCallback({func: cbk, scope: this, storename: 'SystemStore'});
        this.on("afterrender", function(){
            Ext.getCmp("Home").on("show", cbk, this);
        }, this);
        
        //popups
        barco.HomePanel.errpopups = {};
        barco.HomePanel.errpopups[-1992] = new barco.ModalPopup({
            id: "hppopup1",
            title: "Error",
            content: 'Cannot change mode:<br/><span class="texthighlight">Output Format</span> is out of range',
            moreInfo: "Try changing the Output Format to something equal or less than 1920x1200",
            boptionsOn: false
        });
        barco.HomePanel.errpopups[-1993] = new barco.ModalPopup({
            id: "hppopup2",
            title: "Error",
            content: 'Cannot change mode:<br/>An <span class="texthighlight">Input Format</span> is out of range',
            moreInfo: "Make sure that all your connected inputs have a format equal or less than 1920x1200",
            boptionsOn: false
        });
        barco.HomePanel.errpopups[-1994] = new barco.ModalPopup({
            id: "hppopup3",
            title: "Error",
            content: 'Cannot change mode:<br/>An <span class="texthighlight">EDID Format</span> is out of range',
            moreInfo: "Make sure that all your Input EDID formats are equal or less than 1920x1200. "+
                      "You can only do this from the front panel at the moment.",
            boptionsOn: false
        });
        
        barco.HomePanel.warnpopup = new barco.ModalPopup({
            id: "warnpopup1",
            title: "Warning",
            content: "Channel B settings and Logo will be lost",
            moreInfoOn: false,
            boptions: ["cancel", "continue"]
        });
    }
});

Ext.reg('barcohomepanel', barco.HomePanel);

barco.mainui = Ext.extend(Ext.Panel, {
    fullscreen: true,
    id: 'mainpanel',
    layout: 'card',
    items: [
        {
            id: 'Home',
            layout: {
                type: 'vbox',
                pack: 'center',
                align: 'stretch'
            },
            scroll: 'verticle',
            items: [ 
                {
                    xtype: 'barcohomepanel'
                },
                {
                    xtype: 'panel',
                    baseCls: 'noclass',
                    layout: {
                        type: 'vbox',
                        pack: 'center'
                    },
                    items: [
                    {
                        xtype: 'button',
                        ui: 'round',
                        text: 'Save System State',
                        flex: 1,
                        handler: function(btn) {
                            "use strict";
                            var succOrFail = function() {
                                btn.enable();
                            };
                            barco.utils.ascii({
                                request: 'save',
                                success: succOrFail, 
                                failure: succOrFail
                            });
                            btn.disable();
                        }
                    }, {
                            xtype: 'spacer', 
                            height: '30px'
                    }, {
                        xtype: 'button',
                        ui: 'round',
                        text: 'Refresh',
                        flex: 1,
                        id: 'mainRefreshButton',
                        handler: function(btn) {
                            "use strict";
                            var me = this;
                            barco.modelProxy.getResolutionsAndPopulate( function(){
                                barco.modelProxy.load( function(records, operation, success) {
                                    me.enable();
                                });
                            });
                            
                            this.disable();
                        }
                    }
                ]
                }, {
                    xtype: 'spacer',
                    flex: 1     
            }]
        }
    ], //initial items
    backText: 'Back',

    initComponent: function () {
        "use strict";
        var mainui = this, btns, barcoModelName = 'barcomenuModel';
        this.inputSelectBar = new Ext.Toolbar({
            ui: 'light',
            dock: 'top',
            id: 'theinputbar',
            locked: false,
            cls: 'brightButtons',
            timeoutId: null,
            listeners: {
                afterrender: function(bar) {
                    if( Ext.is.Phone && Ext.Viewport.orientation == 'portrait' ) {
                        bar.addCls('inputbarportrait');
                    }
                    barco.modelProxy.addCallback({
                        func: function(xml){
                            if(barco.utils.isImageProJr()){
                                Ext.getCmp('hdmibutton').setVisible(false).setDisabled(true);
                                Ext.getCmp('dpbutton').setVisible(false).setDisabled(true);
                                Ext.getCmp('sdi2button').setVisible(false).setDisabled(true);
                            }
                        },
                        scope: this,
                        //SystemStore not really relevent. 
                        storename: 'SystemStore'
                    });                    
                }
            },
            setLocked: function(status) { 
                this.locked=status; 
                if(status)
                { 
                    var me = this; 
                    //the idea is to give the user a visual cue that the input bar is disabled
                    //if it's been locked for too long (150ms)
                    this.timeoutId = setTimeout( function(){me.disable();}, 150);
                }
                else
                {
                    this.enable();
                    clearTimeout(this.timeoutId);
                }
            },
            layout: {
                pack: 'center',
                align: Ext.is.Phone && Ext.Viewport.orientation == 'portrait' ? 'start' : 'center' //GAN
            },
            defaults: {
                xtype: 'barcotogbutton',
                width: '65px',

                handler: function(btn, evtObj) {
                }
            },
            items: [{
                id: 'dvibutton',
                text: 'DVI'              
            }, {
                id: 'hd15button',
                text: 'HD15'
                //ui: 'confirm-small'
            }, {
                id: 'hdmibutton',
                text: 'HDMI'
                //iconCls: 'action'
            }, {
                id: 'dpbutton',
                text: 'DP'
            }, {
                text: 'SDI 1'
            },{
                //ui: 'round',
                id: 'sdi2button',
                text: 'SDI 2 ',
                listeners: {
                    afterrender: function(cmp) {
                        barco.modelProxy.addCallback(
                        {
                            func: function(xml){
                                if(barco.utils.isSDI_2Ready() === false)
                                {
                                    cmp.disable();
                                }
                            },
                            scope: this,
                            //SystemStore not really relevent. 
                            storename: 'SystemStore'
                        });
                        
                    }
                }
            },{
                //ui: 'round',
                text: 'LOGO'
            }, {
                //ui: 'round',
                text: 'BLK'
            }, {
                xtype: 'button',
                name: 'FreezeMode',
                id: 'fizzle',
                noXMLWrite: false,
                text: 'FRZ',
                listeners: {
                    beforetap: function(evt) {
                        var newVal = this.bpressed ? 0: 1;//toggle it
                        barco.utils.ajaxRequest({
                            request: barco.modelProxy.stores.InputManagerTopLevel.apply({tag: 'FreezeMode', value: newVal}),
                            success: function() {
                                barco.utils.refreshNode(barco.utils.xmlselectnode(barco.tags.FreezeMode), ['SystemStore', 'InputManagerTopLevel']);
                            }
                        });
                    },
                    afterrender: function(cmp) {
                        barco.modelProxy.addCallback({
                            func: function(xml, store) {
                               var freeze = store.data.items[0].data[barco.tags.FreezeMode];
                               if(freeze == "1") {
                                   this.addCls(this.pressedCls);
                                   this.bpressed = true;
                               } else {
                                   this.bpressed = false;
                                   this.removeCls(this.pressedCls);
                               }
                            },
                            storename: 'InputManagerTopLevel',
                            scope: this
                        });   
                    }
                }
            }],
            lightInputBar: function(xml){
                var i, othereye, input = barco.utils.xmlselectnode(barco.tags.ActiveConn).textContent;
                this.items.items.forEach(function(item) {
                    if(item instanceof barco.Togbutton) {
                        item.clearPressed();
                    }
                });
                this.items.items[input].onTapStart(true);
                othereye = barco.mod3D.otherEyeOfInput();//also handles QuadToDual
                if(othereye!==undefined){
                    this.items.items[othereye].setPressed();
                }
            }
        });

        
        this.dockedItems = this.dockedItems || [];
        this.dockedItems.unshift(this.inputSelectBar);
        
        this.on('afterrender',
            function(){
                barco.modelProxy.addCallback({func: this.inputSelectBar.lightInputBar, scope: this.inputSelectBar, storename: 'SystemStore'});
                //barco.modelProxy.addCallback({func: lightInputBar, scope: this, storename: 'UInputStore'});
            }
        );
        
        this.navigationButton = new Ext.Button({
           hidden: Ext.is.Phone || Ext.Viewport.orientation ==  'landscape',
           text: 'Navigation',
           handler: this.onNavButtonTap,
           scope: this
        });

        this.backButton = new Ext.Button({
            text: this.backText,
            ui: 'back',
            handler: this.onUiBack,
            hidden: true,
            scope: this
        });
        
        this.myButton = new Ext.Button({
            id: 'errorButton',
            text: "yatz!",
            ui: 'decline',
            hidden: true,
            scope: this,
            numErrors: 0,
            incError: function()
            {
                this.numErrors += 1;
                this.setText(this.numErrors+" errors");
                this.show();
            },
            handler: function() {
                Ext.getCmp('errorPanel').show();
            },
            resetErrors: function() {
                this.numErrors = 0;
                this.hide();
            }
         });

        btns = [this.navigationButton, {xtype: 'spacer'}, this.myButton];
        if(Ext.is.Phone) {
            btns.unshift(this.backButton);
        }

        this.navigationBar = new Ext.Toolbar({
            id: 'navbar',
            ui: 'dark',
            dock: 'top',
            cls: Ext.is.Phone && 'phonetitle',
            title: this.title,
            items: btns.concat(this.buttons ||[]),
            
            layout: {
                type: 'hbox',
                align: 'center'
            }
        });

        Ext.regModel(barcoModelName, {
                fields:[
                    {name: "text", type:"string"},
                    {name: 'card', type: "string"},
                    {name: 'umbrella', type: "string"}
                ]
        });
        
        barco.StructureStore = new Ext.data.TreeStore({
            model: barcoModelName,
            root: {
                children: barco.treemenu
            },
            proxy: {
                type: 'ajax',
                reader: {
                    type: 'tree',
                    root: 'children'
                }
            }
        });
        this.navigationPanel = new Ext.NestedList({
            store: barco.StructureStore,
            useToolbar: !Ext.is.Phone,
            updateTitleText: false,
            dock: 'left',
            hidden: !Ext.is.Phone && Ext.Viewport.orientation == 'portrait',
            toolbar: Ext.is.Phone ? this.navigationBar: null,
            listeners: {
                itemtap: this.onNavPanelItemTap,
                scope: this
            },
            getTitleTextTpl: function(node) {
                return '<tpl if="umbrella">{umbrella}</tpl> {' + this.displayField + '}';
            }
        });
        
        if( barco.settings.bprocessor ){
            barco.StructureStore.getRootNode().getChildAt(1).getSubStore().removeAt(1); //remove output branch
        }
        
        this.navigationPanel.on('back', this.onNavBack, this);

        if(!Ext.is.Phone) {
            this.navigationPanel.setWidth(220);
        }

        this.dockedItems = this.dockedItems || [];
        this.dockedItems.unshift(this.navigationBar);

        if(!Ext.is.Phone && Ext.Viewport.orientation == 'landscape') {
            this.dockedItems.unshift(this.navigationPanel);
        }
        else if (Ext.is.Phone) {
            this.items = this.items || [];
            this.items.unshift(this.navigationPanel);
        }

        this.addEvents('navigate');

        barco.mainui.superclass.initComponent.call(this);
        
        function load() {
            mainui.loadTestPanel();
        }
        //setTimeout(load, 1000);
    },
    loadTestPanel : function() {
        //For testing code only
        "use strict";
        var card = Ext.getCmp("testpanel");

        if (card) {
            this.setActiveItem(card, 'slide');
            this.currentCard = card;
        }
    },

    toggleUiBackButton: function() {
        "use strict";
        var navPnl = this.navigationPanel, currList, currIdx, recordNode, title, parentNode, backTxt, activeItem;
        
        //console.log("toggleUiBackButton");
        if (Ext.is.Phone) {
            if (this.getActiveItem() === navPnl) {
                currList      = navPnl.getActiveItem();
                currIdx       = navPnl.items.indexOf(currList);
                recordNode    = currList.recordNode;
                title         = navPnl.renderTitleText(recordNode);
                parentNode    = recordNode ? recordNode.parentNode : null;
                backTxt       = (parentNode && !parentNode.isRoot) ? navPnl.renderTitleText(parentNode) : this.title || '';

                if (currIdx <= 0) {
                    this.navigationBar.setTitle(this.title || '');
                    this.backButton.hide();
                } else {
                    this.navigationBar.setTitle(title);
                    if (this.useTitleAsBackText) {
                        this.backButton.setText(backTxt);
                    }

                    this.backButton.show();
                }
            // on a demo
            } else {
                activeItem = navPnl.getActiveItem();
                recordNode = activeItem.recordNode;
                backTxt    = (recordNode && !recordNode.isRoot) ? navPnl.renderTitleText(recordNode) : this.title || '';

                if (this.useTitleAsBackText) {
                    this.backButton.setText(backTxt);
                }
                this.backButton.show();
            }
            this.navigationBar.doLayout();
        }

    },

    onUiBack: function() {
        "use strict";
        var navPnl = this.navigationPanel;

        //console.log("onUiBack");
        // if we already in the nested list
        if (this.getActiveItem() === navPnl) {
            navPnl.onBackTap();
        // we were on a demo, slide back into
        // navigation
        } else {
            this.setActiveItem(navPnl, {
                type: 'slide',
                reverse: true
            });
        }
        this.toggleUiBackButton();
        //this.fireEvent('navigate', this, {});
    },

    onNavPanelItemTap: function(subList, subIdx, el, e) {
        "use strict";
        var store      = subList.getStore(),
            record     = store.getAt(subIdx),
            recordNode = record.node,
            nestedList = this.navigationPanel,
            title      = nestedList.renderTitleText(recordNode),
            card, preventHide, anim, nodeText, cardText, leaf, anims;

        //console.log("onNavPanelItemTap");
        if (record) {
            nodeText    = record.get('text');
            anim        = record.get('cardSwitchAnimation');
            preventHide = record.get('preventHide');
            cardText    = record.get('card');
            leaf        = record.get('leaf');
        }

        if (Ext.Viewport.orientation == 'portrait' && !Ext.is.Phone && !recordNode.childNodes.length && !preventHide) {
            this.navigationPanel.hide();
        }

        card = Ext.getCmp(cardText);//first try cardText
        card = card || Ext.getCmp(nodeText); // then nodeText
        //card = card || new Ext.Panel({html: title + "- Work in progress"});
        if (card) {
            if(Ext.is.Phone) {
                anim = false;
            } else {
                anims = [ 
                    {
                        type: 'slide',
                        direction: 'right'
                    }, {
                        type: 'slide',
                        direction: 'left'
                    }
                ];
                if(anim === undefined) {
                    anim = anims[parseInt(Math.random() * (anims.length), 10)];
                    //console.log(anim.type);
                    Ext.applyIf(anim, {duration: 250});
                }
            }
                        
            this.setActiveItem(card, anim);
            this.currentCard = card;
        }
        else if(leaf){
            console.log("card not found " + cardText);
        }

        if (title && record.data.leaf) {
            this.navigationBar.setTitle(title);
        }                      
        
        this.toggleUiBackButton();
        //this.fireEvent('navigate', this, record);     
        
        if ((cardText == 'panzoom') && (typeof(card.afterSwitch) === "function")) {
            setTimeout(card.afterSwitch, 100);
        }        
    },

    onNavButtonTap : function() {
        "use strict";
        this.navigationPanel.showBy(this.navigationButton, 'fade');
        //console.log("onNavButtonTap");
    },

    layoutOrientation : function(orientation, w, h) {
        "use strict";
        if (!Ext.is.Phone) {
            if (orientation == 'portrait') {
                this.navigationPanel.hide(false);
                this.removeDocked(this.navigationPanel, false);
                if (this.navigationPanel.rendered) {
                    this.navigationPanel.el.appendTo(document.body);
                }
                this.navigationPanel.setFloating(true);
                this.navigationPanel.setHeight(400);
                this.navigationButton.show(false);
                
            }
            else {
                this.navigationPanel.setFloating(false);
                this.navigationPanel.show(false);
                this.navigationButton.hide(false);
                this.insertDocked(0, this.navigationPanel);
            }
            this.navigationBar.doComponentLayout();
            
        }
        else
        {
            barco.adaptInputBar(orientation == 'portrait');
            this.doComponentLayout();
        }
        
        barco.mainui.superclass.layoutOrientation.call(this, orientation, w, h);
    },
    
    adjustInputBar: function(btn) {
        "use strict";
        if(btn == null)
        {
            btn = this.inputSelectBar.items.items[0];
        }
        console.log("adjusting: " + btn.text);
        btn.removeCls('x-button-plain');
        btn.removeCls('barcobtn');
        
    }

});


barco.adaptInputBar = function(isPhoneAndPortrait) { //GAN
    "use strict";
    var ib = Ext.getCmp("theinputbar");
    if(!ib.rendered) {
        return;
    }
    if(isPhoneAndPortrait)
    {
        ib.layout.align = "start";
        ib.doComponentLayout();
        ib.addCls('inputbarportrait');

    }
    else
    {
        ib.layout.align = "center";
        ib.doComponentLayout();
        ib.removeCls('inputbarportrait');
    }
    
};

/*
barco.DisableControlForMinDelay = function(isMinDelay) {
    "use strict";
    
    var i;
    
    // Output Main
    Ext.getCmp('output-1-select').setDisabled(isMinDelay);
    Ext.getCmp('output-2-select').setDisabled(isMinDelay);
    //Ext.getCmp('output-select-3d-packing').setDisabled(isMinDelay);
    //Ext.getCmp('output-select-3d-swap').setDisabled(isMinDelay);   

    // Output Color Effects 
    var length = Ext.getCmp('Color Effects').fields.length;
    for (i=0; i < length; i+=1)
    {
        Ext.getCmp('Color Effects').fields.items[i].disabled = isMinDelay;
        if (Ext.getCmp('Color Effects').fields.items[i].xtype == "barcoslider")
        {
            Ext.getCmp('Color Effects').fields.items[i].slidval.disabled = isMinDelay;        
        }
    }
    
    // Output Color Balance 
    var length = Ext.getCmp('outputcolorbalance').fields.length;
    for (i=0; i < length; i+=1)
    {
        Ext.getCmp('outputcolorbalance').fields.items[i].disabled = isMinDelay;
        if (Ext.getCmp('outputcolorbalance').fields.items[i].xtype == "barcoslider")
        {
            Ext.getCmp('outputcolorbalance').fields.items[i].slidval.disabled = isMinDelay;        
        }
    }
}

*/
