

barco.mod3D = {};

barco.mod3D.leftRightPairs = { 
    0:2, //DVI
    2:0, //HDMI
    4:5, //SDI-1
    5:4  //SDI-2
};

//whether input can have L/R 3D packing mode (currently pairs are SDI-1--SDI-2 and DVI--HDMI
barco.mod3D.isInputLeftRight = function() {
    "use strict";
    var staticInput = parseInt(barco.utils.xmlselect(barco.tags.ActiveConn)[0].textContent, 10);
    return barco.LeftRight3DPairs[staticInput] !== undefined;
};

//whether current input has an associated eye in 3D. Also handles QuadToDual
barco.mod3D.otherEyeOfInput = function() {
    "use strict";
    if(barco.utils.is3DMode() || barco.utils.isQuadToDualMode()){
        var input = parseInt(barco.utils.xmlselect(barco.tags.ActiveConn)[0].textContent, 10);
        if( barco.modelProxy.stores.UInputStore.getAt(0).data.Mode3D == 4 ){
            return barco.mod3D.leftRightPairs[input];
        }
    }
};

barco.mod3D.packingOptions = [
   {text: 'Off', value: '0'}, 
   {text: 'Side by Side', value: '1'},
   {text: 'Top/Bottom', value: '2'},
   {text: 'Sequential', value: '3'},
   {text: 'Left/Right', value: '4'},
   {text: 'FramePack', value: '5'}
];

barco.mod3D.swapOptions = [
	{text: 'L/R', value: '0'}, 
	{text: 'R/L', value: '1'},
	{text: 'L/L', value: '2'},
	{text: 'R/R', value: '3'}
];

barco.mod3D.packingOptionsPerInput = {
   0: barco.utils.filterByIndices(barco.mod3D.packingOptions, [0,1,2,3,4,5]), //DVI
   1: barco.utils.filterByIndices(barco.mod3D.packingOptions, [0]),             //HD-15
   2: barco.utils.filterByIndices(barco.mod3D.packingOptions, [0,1,2,3,4,5]), //HDMI
   3: barco.utils.filterByIndices(barco.mod3D.packingOptions, [0,1,2,3,4,5]),   //DP
   4: barco.utils.filterByIndices(barco.mod3D.packingOptions, [0,1,2,3,4,5]), //SDI-1
   5: barco.utils.filterByIndices(barco.mod3D.packingOptions, [0,1,2,3,4,5])  //SDI-2
};

barco.mod3D.packingOptionsPerOutput = {
   0: barco.utils.filterByIndices(barco.mod3D.packingOptions, [1,2,3,4]), //DVI
   1: barco.utils.filterByIndices(barco.mod3D.packingOptions, [1,2,3,4]),             //HD-15
   2: barco.utils.filterByIndices(barco.mod3D.packingOptions, [1,2,3,4]), //HDMI
   3: barco.utils.filterByIndices(barco.mod3D.packingOptions, [1,2,3]),   //DP
   4: barco.utils.filterByIndices(barco.mod3D.packingOptions, [1,2,3,4]), //SDI-1
   5: barco.utils.filterByIndices(barco.mod3D.packingOptions, [1,2,3,4])  //SDI-2
};

barco.mod3D.packingSelector = {
        xtype: 'selectfield',
        name: barco.tags.Mode3D,
        label: '3D Packing Mode',
        options: barco.mod3D.packingOptions,
        setLROptions: function(isInput, isDualPixel){
            "use strict";
            var input = parseInt(barco.utils.xmlselect(barco.tags.ActiveConn)[0].textContent, 10);
            if(isInput){
                this.setOptions(barco.mod3D.packingOptionsPerInput[input]);
            }else{
                if(isDualPixel){
                    this.setOptions(barco.utils.filterByIndices(barco.mod3D.packingOptions, [1,2,3]));
                }else{
                    this.setOptions(barco.mod3D.packingOptionsPerOutput[input]);
                }
            }
        },
        setFPOptions: function(){
            "use strict";
            this.setOptions( barco.utils.filterByIndices(barco.mod3D.packingOptions, [5]) );
        }
};

barco.mod3D.swapSelector = {
    xtype: 'selectfield',
    name: barco.tags.Swap3D,
    label: '3D Swap',
    options: barco.mod3D.swapOptions
};
