
barco.Togbutton = Ext.extend(Ext.Button, {

    constructor: function(config) {
        "use strict";
        barco.Togbutton.superclass.constructor.call(this, config);
    },
    
    onPress : function(e) {
        "use strict";
        //do nothing
    },
    
    onTapStart : function(e) {
        "use strict";
        var me = this, chosen, i, old;
        if(me.disabled) 
        { return; }
    
        for(i=0; i<me.ownerCt.items.items.length; i+=1)
        {
            if(me.text==me.ownerCt.items.items[i].text)
            {
                chosen = i;
            }
        }
        if(chosen === undefined)
        {
            return;
        }
        if(e===true)
        {
            me.el.addCls(me.pressedCls);
        }
        else if(!me.ownerCt.locked)
        {
            old = barco.utils.xmlselect("ActiveConn")[0].textContent;
            if(old !== undefined)
            {
                Ext.getCmp('theinputbar').items.items[old].clearPressed();
            }
            barco.utils.selectInput(chosen);
            //for a quicker response:
            barco.utils.xmlselect("ActiveConn")[0].textContent = chosen;
            barco.modelProxy.modelChanged();
        }
    },
    onTapCancel : function() {
        "use strict";
        var me = this;
        if (me.pressedTimeout) {
            clearTimeout(me.pressedTimeout);
            delete me.pressedTimeout;
        }
        //me.el.removeCls(me.pressedCls);
    },
    
    clearPressed : function() {
        "use strict";
        this.el.removeCls(this.pressedCls);
    },
    
    setPressed : function() {
        "use strict";
        this.el.addCls(this.pressedCls);
    }
    

});

Ext.reg('barcotogbutton', barco.Togbutton);


///a button that simply toggles, barely changed regular Ext.Button
//toggleState has current value
barco.JustATogbutton = Ext.extend(Ext.Button, {
    constructor: function(config) {
        "use strict";
        barco.JustATogbutton.superclass.constructor.call(this, config);
        this.toggleState = false;
    },
    onTapStart : function() {
        "use strict";
        this.toggleState = !this.toggleState;
        var me = this, func = (this.toggleState ? "addCls" : "removeCls");
        if (!me.disabled) {
            if (me.pressedDelay) {
                me.pressedTimeout = setTimeout(function() {
                    me.el[func](me.pressedCls);
                }, Ext.isNumber(me.pressedDelay) ? me.pressedDelay : 100);
            }
            else {
                me.el[func](me.pressedCls);
            }
        }
    },
    onTapCancel : function() {
        "use strict";
        var me = this;
        if (me.pressedTimeout) {
            clearTimeout(me.pressedTimeout);
            delete me.pressedTimeout;
        }
        //should correct for timeout
    },
    resetToggle : function(){
        "use strict";
        this.el.removeCls(this.pressedCls);
        this.toggleState = false;
    }
    
    
});

Ext.reg('togbutton', barco.JustATogbutton);



